import numpy as np
import neighborhood_analysis as na
from neighborhood_analysis import CellCombs, get_point_neighbors, get_bbox_neighbors,comb_bootstrap

from time import time

types = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']
points = np.random.randint(0, 1000, (10000, 2))
corr_types = np.random.choice(types, 10000)
points = [(x, y) for (x, y) in points]

bbox = []
for _ in range(100):
    ix1, ix2 = np.random.choice(range(len(points)), 2)
    if points[ix1][0] < points[ix2][0]:
        bbox.append((*points[ix1], *points[ix2]))
    else:
        bbox.append((*points[ix2], *points[ix1]))

start = time()
neighbors = get_bbox_neighbors(bbox, 2)
end = time()
print(f"search bbox neighbors used {(end-start):.2f}s")


start = time()
neighbors = get_point_neighbors(points, 10.0)
end = time()
print(f"search point neighbors used {(end-start):.2f}s")

start = time()

cc = CellCombs(types, False)
results = cc.bootstrap(corr_types, neighbors, ignore_self=True)
print(results)

end = time()
print(f"used {(end-start):.2f}s")

s1 = time()
X = [bool(i) for i in np.random.choice([True, False], 10000)]
Y = [bool(i) for i in np.random.choice([True, False], 10000)]
v = comb_bootstrap(X, Y, neighbors, ignore_self=True)
s2 = time()
print(f"used {(s2-s1):.2f}s")
